/*

    @author DanielD

    ========== licence begin GPL
    Copyright (C) 2002-2003 SAP AG

    This program is free software; you can redistribute it and/or
    modify it under the terms of the GNU General Public License
    as published by the Free Software Foundation; either version 2
    of the License, or (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
    ========== licence end


*/

package com.sap.dbtech.procserver;

import com.sap.dbtech.jdbc.ConnectionSapDB;

/**
 *
 */
public class ProcServerConnection
    extends ConnectionSapDB
{
    /**
     * creates a new ProcServerConnection
     */
    public 
    ProcServerConnection (
        com.sap.dbtech.rte.comm.JdbcCommunication session)
    throws java.sql.SQLException
    {
        super (session, new java.util.Properties ());
    }
    /**
     * skip CONNECT statement because ProcServer uses existing session
     */
    protected void doConnect (
        java.util.Properties info)
    throws java.sql.SQLException
    {
    }
    /**
     * reconnect is impossible, pass original exception
     */
    protected void tryReconnect (
        com.sap.dbtech.rte.comm.RTEException outerRteExc)
    throws java.sql.SQLException
    {
        throw new com.sap.dbtech.jdbc.exceptions.ConnectionException (outerRteExc);
    }

}
